﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace _16DIFSample
{
    public partial class BitPatternDisp : Form
    {
        private System.Windows.Forms.Label[] BITDISP;
        public BitPatternDisp()
        {
            InitializeComponent();

            this.BITDISP = new System.Windows.Forms.Label[]
            {this.Bit0, this.Bit1, this.Bit2, this.Bit3, this.Bit4, this.Bit5, 
             this.Bit6, this.Bit7, this.Bit8, this.Bit9, this.Bit10, this.Bit11, 
             this.Bit12, this.Bit13, this.Bit14, this.Bit15};
        }

        public void DispLowByte(byte num, string Message)
        {
            int Bit;

            MessageTxt.Text = Message;

            for (Bit = 0; Bit < 8; Bit++)
            {
                BITDISP[Bit].Visible = true;
                BITDISP[Bit].Text = "Bit"+ Bit.ToString() + (((num & (1<<Bit))!=0) ? "[H]" : "[L]");
            }
            for (Bit = 8; Bit < 16; Bit++)
            {
                BITDISP[Bit].Visible = false;
            }

            this.ShowDialog();
        }

        public void DispHighByte(byte num, string Message)
        {
            int Bit;

            MessageTxt.Text = Message;

            for (Bit = 0; Bit < 8; Bit++)
            {
                BITDISP[Bit].Visible = false;
            }
            for (Bit = 8; Bit < 16; Bit++)
            {
                BITDISP[Bit].Visible = true;
                BITDISP[Bit].Text = "Bit" + Bit.ToString() + (((num & (1 << (Bit - 8))) != 0) ? "[H]" : "[L]");
            }

            this.ShowDialog();
        }

        public void DispWord(int num, string Message)
        {
            int Bit;

            MessageTxt.Text = Message;

            for (Bit = 0; Bit < 16; Bit++)
            {
                BITDISP[Bit].Visible = true;
                BITDISP[Bit].Text = "Bit" + Bit.ToString() + (((num & (1 << Bit)) != 0) ? "[H]" : "[L]");
            }

            this.ShowDialog();
        }

        private void OKBtn_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
