﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace _16DIFSample
{
    public partial class BitPatternSet : Form
    {
        private System.Windows.Forms.CheckBox[] BITCHK;
        Boolean RetState;

        public BitPatternSet()
        {
            InitializeComponent();

            BITCHK = new System.Windows.Forms.CheckBox[]
            {this.Bit0, this.Bit1, this.Bit2, this.Bit3, this.Bit4, this.Bit5, 
             this.Bit6, this.Bit7, this.Bit8, this.Bit9, this.Bit10, this.Bit11, 
             this.Bit12, this.Bit13, this.Bit14, this.Bit15};
        }

        public Boolean GetLowByte(ref byte num, string Message)
        {
            int Bit;

            MessageTxt.Text = Message;

            for(Bit = 0; Bit < 8; Bit++)
            {
                BITCHK[Bit].Checked = (num & (1 << Bit)) != 0;
                BITCHK[Bit].Enabled = true;
            }
            for (Bit = 8; Bit < 16; Bit++)
            {
                BITCHK[Bit].Checked = false;
                BITCHK[Bit].Enabled = false;
            }

            RetState = false;
            this.ShowDialog();

            if (RetState)
            {
                num = 0;
                for (Bit = 0; Bit < 8; Bit++)
                    num += (byte)((BITCHK[Bit].Checked) ? (1 << Bit) : 0);
            }
            return RetState;
        }

        public Boolean GetHighByte(ref byte num, string Message)
        {
            int Bit;

            MessageTxt.Text = Message;

            for (Bit = 0; Bit < 8; Bit++)
            {
                BITCHK[Bit].Checked = false;
                BITCHK[Bit].Enabled = false;
            }
            for (Bit = 8; Bit < 16; Bit++)
            {
                BITCHK[Bit].Checked = (num & (1 << (Bit-8))) != 0;
                BITCHK[Bit].Enabled = true;
            }

            RetState = false;
            this.ShowDialog();

            if (RetState)
            {
                num = 0;
                for (Bit = 0; Bit < 8; Bit++)
                    num += (byte)((BITCHK[Bit+8].Checked) ? (1 << Bit) : 0);
            }
            return RetState;
        }

        public Boolean GetWord(ref int num, string Message)
        {
            int Bit;

            MessageTxt.Text = Message;

            for (Bit = 0; Bit < 16; Bit++)
            {
                BITCHK[Bit].Checked = (num & (1 << Bit)) != 0;
                BITCHK[Bit].Enabled = true;
            }

            RetState = false;
            this.ShowDialog();

            if (RetState)
            {
                num = 0;
                for (Bit = 0; Bit < 16; Bit++)
                    num += (BITCHK[Bit].Checked) ? (1<<Bit) : 0;
            }
            return RetState;
        }

        private void AllChkBtn_Click(object sender, EventArgs e)
        {
            int Bit;
            for (Bit = 0; Bit < 16; Bit++)
            {
                if (BITCHK[Bit].Enabled)
                    BITCHK[Bit].Checked = true;
            }
        }

        private void AllClrBtn_Click(object sender, EventArgs e)
        {
            int Bit;
            for (Bit = 0; Bit < 16; Bit++)
            {
                if (BITCHK[Bit].Enabled)
                    BITCHK[Bit].Checked = false;
            }
        }

        private void OKBtn_Click(object sender, EventArgs e)
        {
            RetState = true;
            this.Close();
        }

        private void CancelBtn_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
