﻿Public Class BitPatternDisp
    Private BITDISP() As System.Windows.Forms.Label

    Public Sub New()

        ' この呼び出しはデザイナーで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後で初期化を追加します。
        Me.BITDISP = New System.Windows.Forms.Label() _
            {Me.Bit0, Me.Bit1, Me.Bit2, Me.Bit3, Me.Bit4, Me.Bit5, _
             Me.Bit6, Me.Bit7, Me.Bit8, Me.Bit9, Me.Bit10, Me.Bit11, _
             Me.Bit12, Me.Bit13, Me.Bit14, Me.Bit15}
    End Sub

    Public Sub DispLowByte(ByVal num As Byte, ByVal Message As String)
        Dim Bit As Integer

        MessageTxt.Text = Message

        For Bit = 0 To 7
            BITDISP(Bit).Visible = True
            BITDISP(Bit).Text = "Bit" + Bit.ToString + IIf((num And (1 << Bit)) <> 0, "[H]", "[L]")
        Next
        For Bit = 8 To 15
            BITDISP(Bit).Visible = False
        Next

        Me.ShowDialog()
    End Sub

    Public Sub DispHighByte(ByVal num As Byte, ByVal Message As String)
        Dim Bit As Integer

        MessageTxt.Text = Message

        For Bit = 0 To 7
            BITDISP(Bit).Visible = False
        Next
        For Bit = 8 To 15
            BITDISP(Bit).Visible = True
            BITDISP(Bit).Text = "Bit" + Bit.ToString + IIf((num And (1 << (Bit - 8))) <> 0, "[H]", "[L]")
        Next

        Me.ShowDialog()
    End Sub

    Public Sub DispWord(ByVal num As Integer, ByVal Message As String)
        Dim Bit As Integer

        MessageTxt.Text = Message

        For Bit = 0 To 15
            BITDISP(Bit).Visible = True
            BITDISP(Bit).Text = "Bit" + Bit.ToString + IIf((num And (1 << Bit)) <> 0, "[H]", "[L]")
        Next

        Me.ShowDialog()
    End Sub

    Private Sub OKBtn_Click(sender As System.Object, e As System.EventArgs) Handles OKBtn.Click
        Me.Close()
    End Sub
End Class