//-----------------------------------------------
//API for TUSB-16DIF Driver
//Visual C++/CLI Module
//
//Jan. 28 2014
//Copyright (C) 2014 Turtle Industry Co.,Ltd.
//-----------------------------------------------

#ifndef TUSBDIF_h
#define TUSBDIFD_h

using namespace System;
using namespace System::Runtime::InteropServices;

//API extern short declaration
[DllImport("TUSBDIF.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdif_Device_Open(short Id);
[DllImport("TUSBDIF.DLL", CallingConvention = CallingConvention::Cdecl)]
extern void Tusbdif_Device_Close(short Id);
[DllImport("TUSBDIF.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdif_High_Dir(short Id, unsigned char dirR);
[DllImport("TUSBDIF.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdif_Low_Dir(short Id, unsigned char dirR);
[DllImport("TUSBDIF.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdif_LowByte_Write(short Id, unsigned char dat);
[DllImport("TUSBDIF.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdif_HighByte_Write(short Id, unsigned char dat);
[DllImport("TUSBDIF.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdif_LowByte_Read(short Id, unsigned char *dat);
[DllImport("TUSBDIF.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdif_HighByte_Read(short Id, unsigned char *dat);
[DllImport("TUSBDIF.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdif_Word_Write(short Id, int dat);
[DllImport("TUSBDIF.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdif_Word_Read(short Id, int *dat );
static String^ Tusbdif_GetErrMessage(short retcode)
{
    switch (retcode)
    {
        case 0:
            return "I܂";
        case 1:
            return "IDԍsł";
        case 2:
            return "hCoCXg[Ă܂";
        case 3:
            return "łɃfoCX̓I[vĂ܂";
        case 4:
            return "ڑĂ䐔܂";
        case 5:
            return "I[vł܂ł";
        case 6:
            return "foCX݂܂";
        case 8:
            return "p[^G[";
        case 9:
            return "USBʐMG[ł";
        default:
            return "sȃG[ł";
    }
}
#endif
